/*
 * ofxHttpEvents.h
 *
 *  Created on: 11-oct-2008
 *      Author: art
 */

#ifndef OFXMAILEVENTS_H_
#define OFXMAILEVENTS_H_

#include "ofxMailUtils.h"

class ofxPop3EventListener{
public:
	virtual void newMessage( ofxMailMessage & message ){};
	void newMessage(const void * sender, ofxMailMessage & response){
		newMessage(response);
	}
};

class ofxPop3EventManager{
public:
	ofxPop3EventManager(ofxPop3ClientUtils * sender){
		this->sender=sender;
	}
	void addListener(ofxPop3EventListener * listener){
		messageEvent += Poco::Delegate<ofxPop3EventListener,ofxMailMessage>(listener,&ofxPop3EventListener::newMessage);
	}

	void removeListener(ofxPop3EventListener * listener){
		messageEvent += Poco::Delegate<ofxPop3EventListener,ofxMailMessage>(listener,&ofxPop3EventListener::newMessage);
	}

	void notifyNewMessage(ofxMailMessage message){
		messageEvent.notify(sender,message);
	}
protected:
	Poco::BasicEvent<ofxMailMessage> messageEvent;
	ofxPop3ClientUtils * sender;
};

extern ofxPop3EventManager ofxMailEvents;
#endif /* OFXHTTPEVENTS_H_ */
