/*
    ofxMailUtils
    author: arturo
*/

#include "ofxMailUtils.h"
#include "ofxMailEvents.h"

// ----------------------------------------------------------------------
ofxSmtpClientUtils::ofxSmtpClientUtils(){
	session=new Poco::Net::SMTPClientSession(OFX_SMTP_HOST,OFX_SMTP_PORT);
	session->login();
}
// ----------------------------------------------------------------------
ofxSmtpClientUtils::~ofxSmtpClientUtils(){
    stop();
}
//-------------------------------
// non blocking functions
void ofxSmtpClientUtils::addMessage(ofxMailMessage message){
	messages.push(message);
	if(!isThreadRunning())
		start();
}

//-------------------------------
// blocking functions
void ofxSmtpClientUtils::sendMessage(ofxMailMessage & message){
	session->sendMessage(message.getPocoMessage());
}


// ----------------------------------------------------------------------
void ofxSmtpClientUtils::start() {
     if (isThreadRunning() == false){
        printf("thread started\n");
        startThread(true,true);
    }
}
// ----------------------------------------------------------------------
void ofxSmtpClientUtils::stop() {
    stopThread();
}
// ----------------------------------------------------------------------
void ofxSmtpClientUtils::threadedFunction(){

    // loop through this process whilst thread running
    while( isThreadRunning() == true ){
    	if(messages.size()){
    		sendMessage(messages.front());
    		messages.pop();
    	}else{
    		stop();
    	}

    }

}


ofxSmtpClientUtils ofxSmtpClient;

